From d217ecc1d13ff00b1700568ae0564eb23d18f7e9 Mon Sep 17 00:00:00 2001
From: Alexander Golubev <fatzer2@gmail.com>
Date: Fri, 16 Aug 2013 05:58:41 +0400
Subject: [PATCH] add check if demangle.h present on system or not

---
 CMakeLists.txt                  |  1 +
 config.h.cmake                  |  3 +++
 tdeio/tdeio/backtrace_symbols.c | 14 +++++++++++---
 tdeio/tdeio/slavebase.cpp       | 10 ++++------
 4 files changed, 19 insertions(+), 9 deletions(-)

diff --git a/CMakeLists.txt b/CMakeLists.txt
index 1a32216..430e5ee 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -205,6 +205,7 @@ check_include_file( "termio.h" HAVE_TERMIO_H )
 check_include_file( "unistd.h" HAVE_UNISTD_H )
 check_include_file( "util.h" HAVE_UTIL_H )
 check_include_file( "values.h" HAVE_VALUES_H )
+check_include_file( "demangle.h" HAVE_DEMANGLE_H )
 
 # FIXME I'm not sure if test TIME_WITH_SYS_TIME are correct
 check_include_file( "sys/time.h" HAVE_SYS_TIME_H )
diff --git a/config.h.cmake b/config.h.cmake
index f420d04..9d1ffa0 100644
--- a/config.h.cmake
+++ b/config.h.cmake
@@ -653,6 +653,9 @@
 /* Define to 1 if you have the <values.h> header file. */
 #cmakedefine HAVE_VALUES_H 1
 
+/* Define to 1 if you have the <demangle.h> header file from binutils package. */
+#cmakedefine HAVE_DEMANGLE_H 1
+
 /* Define, to enable volume management (Solaris 2.x), if you have -lvolmgt */
 #undef HAVE_VOLMGT
 
diff --git a/tdeio/tdeio/backtrace_symbols.c b/tdeio/tdeio/backtrace_symbols.c
index 69aa2d7..75a0dcf 100644
--- a/tdeio/tdeio/backtrace_symbols.c
+++ b/tdeio/tdeio/backtrace_symbols.c
@@ -35,6 +35,11 @@
    along with this program; if not, write to the Free Software
    Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
 
+#include "config.h"
+
+#ifndef NDEBUG 
+#ifdef HAVE_DEMANGLE_H
+
 #define fatal(a, b) exit(1)
 #define bfd_fatal(a) exit(1)
 #define bfd_nonfatal(a) exit(1)
@@ -42,20 +47,21 @@
 
 /* 2 characters for each byte, plus 1 each for 0, x, and NULL */
 #define PTRSTR_LEN (sizeof(void *) * 2 + 3)
-#define true 1
-#define false 0
 
-#define _GNU_SOURCE
 #include <string.h>
 #include <stdio.h>
 #include <stdlib.h>
+#include <stdbool.h>
 #include <execinfo.h>
 #include <bfd.h>
 #include <libiberty.h>
 #include <dlfcn.h>
 #include <link.h>
+
 #include <demangle.h>
 
+#warning Here is a big bunch of c-code drained from binutils to quickly fix a TDE bug; This need to be rewriten
+// FIXME: after rewriting may be it's better to move it to tdecore/kdebug.cpp
 
 static asymbol **syms;		/* Symbol table.  */
 
@@ -323,3 +329,5 @@ backtrace_symbols_fd(void *const *buffer, int size, int fd)
         free(strings);
 }
 
+#endif // HAVE_DEMANGLE_H
+#endif // NDEBUG 
diff --git a/tdeio/tdeio/slavebase.cpp b/tdeio/tdeio/slavebase.cpp
index d4aa8ca..83b2a98 100644
--- a/tdeio/tdeio/slavebase.cpp
+++ b/tdeio/tdeio/slavebase.cpp
@@ -66,10 +66,10 @@
 #endif
 #endif
 
-#ifndef NDEBUG
-#ifdef HAVE_BACKTRACE
+#ifndef NDEBUG 
 void print_trace()
 {
+#if	defined(HAVE_BACKTRACE) && defined(HAVE_DEMANGLE_H)
 	void *array[10];
 	size_t size;
 	char **strings;
@@ -85,9 +85,9 @@ void print_trace()
 	}
 
 	free (strings);
+#endif // defined(HAVE_BACKTRACE) && defined(HAVE_DEMANGLE_H)
 }
-#endif
-#endif
+#endif // NDEBUG
 
 using namespace TDEIO;
 
@@ -765,10 +765,8 @@ void SlaveBase::sigsegv_handler(int sig)
     snprintf(buffer, sizeof(buffer), "tdeioslave: ####### CRASH ###### protocol = %s pid = %d signal = %d\n", s_protocol, getpid(), sig);
     write(2, buffer, strlen(buffer));
 #ifndef NDEBUG
-#ifdef HAVE_BACKTRACE
     print_trace();
 #endif
-#endif
     ::exit(1);
 #endif
 }
-- 
1.8.1.5

